<?php

$payment_page_uri = add_query_arg('payment', 'paypal', get_permalink());
$payment_page_uri = add_query_arg('ebook_id', $id, $payment_page_uri);

$settings_general_payment_notify_email = !empty($editionguard_options['settings_general_payment_notify_email']) ? $editionguard_options['settings_general_payment_notify_email'] : '';
$settings_paypal_email = !empty($editionguard_options['settings_paypal_email']) ? $editionguard_options['settings_paypal_email'] : '';
$settings_paypal_test_mode = !empty($editionguard_options['settings_paypal_test_mode']) ? $editionguard_options['settings_paypal_test_mode'] : true;


define('PAYMENT_NOTIFY_EMAILID', $settings_general_payment_notify_email);
define('PAYPAL_MERCHANT_ID', $settings_paypal_email);
if ($settings_paypal_test_mode == 'Yes')
    define('PAYPAL_URL', 'https://www.sandbox.paypal.com/cgi-bin/webscr');
else
    define('PAYPAL_URL', 'https://www.paypal.com/cgi-bin/webscr');

require_once('paypal.class.php');
$_SESSION['user_id'] = 1;

//Creating Objects and variables
$paypal_obj = new EditionGuard_Paypal(); // initiate an instance of the class
$paypal_obj->paypal_url = PAYPAL_URL;   // testing paypal url
$paypal_obj->ipn_log_file = 'logs/ipn_log.txt';
$paypal_obj->error_email = PAYMENT_NOTIFY_EMAILID;

// setup a variable for this script.
//$payment_page_uri = add_query_arg( 'action', 'process', $payment_page_uri );
$this_script = $payment_page_uri;

$button_output = $payment_form_submit_error = '';
// if there is not action variable, set the default action of 'process'
//if (empty($_GET['action'])) $_GET['action'] = 'process';


if (!empty($_REQUEST['action'])) {
    switch ($_REQUEST['action']) {

        case 'process':      // Process and order...
//require_once ('check_session.php');//check user is logged in or not.
// There should be no output at this point.  To process the POST data,
// the submit_paypal_post() function will output all the HTML tags which
// contains a FORM which is submited instantaneously using the BODY onload
// attribute.  In other words, don't echo or printf anything when you're
// going to be calling the submit_paypal_post() function.
// This is where you would have your form validation  and all that jazz.
// You would take your POST vars and load them into the class like below,
// only using the POST values instead of constant string expressions.
// For example, after ensureing all the POST variables from your custom
// order form are valid, you might have:
//
// $paypal_obj->add_field('first_name', $_POST['first_name']);
// $paypal_obj->add_field('last_name', $_POST['last_name']);

            $paypal_obj->add_field('business', PAYPAL_MERCHANT_ID);

            $return_page_uri = add_query_arg('action', 'success', $this_script);
            $paypal_obj->add_field('return', $return_page_uri);

            $cancel_return_page_uri = add_query_arg('action', 'cancel', $this_script);
            $paypal_obj->add_field('cancel_return', $this_script . '?action=cancel');
//Since the session will not exist in the validate_ipn we need to send those as query string.
            $notify_url_page_uri = add_query_arg('action', 'ipn', $this_script);
            $notify_url_page_uri = add_query_arg('user_id', $_SESSION['user_id'], $notify_url_page_uri);
            $paypal_obj->add_field('notify_url', $notify_url_page_uri);

            $paypal_obj->add_field('first_name', $_REQUEST['first_name']);
            $paypal_obj->add_field('last_name', $_REQUEST['last_name']);
            $paypal_obj->add_field('item_number', $_REQUEST['item_number']);
            $paypal_obj->add_field('item_name', $_REQUEST['item_name']);
            $paypal_obj->add_field('amount', $_REQUEST['total_cost']);
            $paypal_obj->add_field('no_shipping', "1");
            $paypal_obj->add_field("shipping", "0");
            $paypal_obj->add_field('page_style', "primary");
            $paypal_obj->add_field('image_url', $base_url . "images/paypal_logo.jpg");

            $paypal_obj->add_field('currency_code', $_REQUEST['currency_code']);
//$paypal_obj->add_field('city', "city");
//$paypal_obj->add_field('state', "state");
//$paypal_obj->add_field('zip', "12345");
            if ($_REQUEST['item_number'] == "" || $_REQUEST['item_name'] == "" || $_REQUEST['total_cost'] == "" || $_REQUEST['first_name'] == "" || $_REQUEST['last_name'] == "" || $_REQUEST['email'] == "") {
                $payment_form_submit_error = '<p class="payment_validation_error">All fields are required for a valid payment request!</p>';
            } else if (!is_email($_REQUEST['email'])) {
                $payment_form_submit_error = '<p class="payment_validation_error">Please enter a valid e-mail address.</p>';
            } else {
                /*  $sql = "CREATE TABLE IF NOT EXISTS ".TABLE_EBOOKS_ORDERS." (
                  `id` int(11) NOT NULL AUTO_INCREMENT,
                  `ebook_id` int(11) NOT NULL,
                  `ebook_title` varchar(255) NOT NULL,
                  `first_name` varchar(120) NOT NULL,
                  `last_name` varchar(120) NOT NULL,
                  `email` varchar(200) NOT NULL,
                  `amount` float NOT NULL,
                  `payment_status` enum('Pending','Successful','Unsuccessful','Failed','Denied','Refunded','Canceled') NOT NULL DEFAULT 'Pending',
                  `payment_method` varchar(120) DEFAULT NULL,
                  `payment_currency` varchar(20) DEFAULT NULL,
                  `order_status` enum('Waiting','Completed') NOT NULL DEFAULT 'Waiting',
                  `download_link` varchar(255) DEFAULT NULL,
                  `created` datetime NOT NULL,
                  `ipn_data` text,
                  PRIMARY KEY (`id`)
                  ) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
                  $wpdb->query($sql); */

                //Inserting pending orders    
                $sql = 'INSERT INTO ' . TABLE_EBOOKS_ORDERS . ' 
        set 
        ebook_id="' . $_REQUEST['item_number'] . '",              
        ebook_title="' . $_REQUEST['item_name'] . '",              
        first_name="' . strip_tags($_REQUEST['first_name']) . '",
        last_name="' . strip_tags($_REQUEST['last_name']) . '",
        email="' . strip_tags($_REQUEST['email']) . '",
        amount="' . strip_tags($_REQUEST['total_cost']) . '",
        payment_status="Pending",
        payment_method="Paypal",
        payment_currency="' . $_REQUEST['currency_code'] . '",       
        order_status="Waiting",       
        created=concat(CURDATE()," ",CURTIME())
        ';

                if ($wpdb->query($sql)) {
                    $msg = 'eBook order information has been saved successfully!';
                    $order_id = mysql_insert_id();
                    $paypal_obj->add_field('custom', $order_id);

                    $button_output = $paypal_obj->submit_paypal_post(); // submit the fields to paypal
                } else {
                    //$msg = $sql;
                    $button_output = '<p class="thankyou_heading">Order information can not be saved!</p>';
                }
            }
//$paypal_obj->dump_fields();      // for debugging, output a table of all the fields
            break;

        case 'success':      // Order was successful...
// This is where you would probably want to thank the user for their order
// or what have you.  The order information at this point is in POST
// variables.  However, you don't want to "process" the order until you
// get validation from the IPN.  That's where you would have the code to
// email an admin, update the database with payment status, activate a
// membership, etc.

            $button_output = '';
            $button_output.= "<h1 class='thankyou_heading'>Thank you for your order.</h1>";
//foreach ($_POST as $key => $value) { $button_output.= "$key: $value<br>"; }
//$button_output.= "</body></html>";
// You could also simply re-direct them to another page, or your own
// order status page which presents the user with the status of their
// order based on a database (which can be modified with the IPN code
// below).

            break;

        case 'cancel':       // Order was canceled...
// The order was canceled before being completed.
//header("Location: cancel_order.php");
            $button_output = 'The order was canceled before being completed';
            break;

        case 'ipn':          // Paypal is calling page for IPN validation...
// It's important to remember that paypal calling this script.  There
// is no output here.  This is where you validate the IPN data and if it's
// valid, update your database to signify that the user has payed.  If
// you try and use an echo or printf function here it's not going to do you
// a bit of good.  This is on the "backend".  That is why, by default, the
// class logs all IPN data to a text file.

            $ipn_validation = $paypal_obj->validate_ipn();
//this function will set the value to $paypal_obj->ipn_data array
// Check the paypal documentation for specifics on what information
// is available in the IPN POST variables.  Basically, all the POST vars
// which paypal sends, which we send back for validation, are now stored
// in the ipn_data() array.
// For this example, we'll just email ourselves ALL the data.
// email header
            $em_headers = "From: " . $paypal_obj->ipn_data['first_name'] . " <" . $paypal_obj->ipn_data['payer_email'] . ">\n";
            $em_headers .= "Reply-To: " . $paypal_obj->ipn_data['payer_email'] . "\n";
            $em_headers .= "Return-Path: " . $paypal_obj->ipn_data['payer_email'] . "\n";

//create and set the values to session again --IMPORTANTTTTTTT
            $_SESSION['user_id'] = $_REQUEST['user_id'];



            $save_status = true; //saveTransactionDetails($paypal_obj->ipn_data);
            if (!$save_status) {
                $paypal_obj->error_out("This was a duplicate transaction", $em_headers);
            }
            if (!$ipn_validation) {
                $body = 'IPN validation is failed for the following transaction<br/>';
                $text .= "IPN POST Vars from Paypal:<br/>";
                foreach ($_POST as $key => $value) {
                    $text .= "$key=$value,<br/>";
                }
                $body .= $text;
                $body .= 'Please see the log file for more details.';
                $paypal_obj->error_out($body, $em_headers);
            }

            switch ($paypal_obj->ipn_data['payment_status']) {

                case 'Pending':
                    $pending_reason = $paypal_obj->ipn_data['pending_reason'];

                    $order_id = $paypal_obj->ipn_data['custom'];
                    $sql = "select * from " . TABLE_EBOOKS_ORDERS . " where id='" . $order_id . "'";
                    $order_data = $wpdb->get_row($sql);

                    if (empty($author))
                        $author = 'N/A';
                    if (empty($publisher))
                        $publisher = 'N/A';
                    if (empty($description))
                        $description = 'N/A';

                    $return_options_data = editionguard_get_all_options();
                    $senderName = !empty($return_options_data['settings_general_checkout_email_sender_name']) ? $return_options_data['settings_general_checkout_email_sender_name'] : 'Support';
                    $senderEmail = !empty($return_options_data['settings_general_checkout_email_sender_email']) ? $return_options_data['settings_general_checkout_email_sender_email'] : 'support@email.com';


                    $body = "Hi " . $order_data->first_name . ' ' . $order_data->last_name . ",
    
Thank you for shopping with us! Your order information is listed below for your convenience.

Order Details:
Order ID: $order_id
Order Status: Pending
Pending Reason: " . ucfirst($pending_reason) . " 

eBook Details:
eBook Title: $title
Author: $author
Publisher: $publisher
eBook Download Link: N/A 
Details: $description

Editionguard.com        
";
                    $headers = "From: $senderName <" . $senderEmail . ">\n";
                    $headers .= "Reply-To: " . $senderEmail . "\n";
                    $headers .= "Return-Path: " . $senderEmail . "\n";

                    mail($order_data->email, 'Pending Payment Notification', $body, $headers);
//mail(PAYMENT_NOTIFY_EMAILID, 'Pending Payment Notification', $body . ' ' .__FILE__, $headers);                                       
                    if ($pending_reason != "intl") {
                        $paypal_obj->error_out("Pending Payment - $pending_reason", $em_headers);

                        break;
                    }
                case 'Completed':
                    if ($paypal_obj->paypal_post_vars['txn_type'] == "reversal") {
                        $reason_code = $paypal_obj->paypal_post_vars['reason_code'];
                        $paypal_obj->error_out("PayPal reversed an earlier transaction.", $em_headers);
// you should mark the payment as disputed now
//mail(PAYMENT_NOTIFY_EMAILID, 'Completed PayPal reversed an earlier transaction', 'This email is sending for debuging purpose only '.__FILE__);                                       
                    } else {

                        if ($save_status) {

                            $ipn_data = serialize($paypal_obj->ipn_data);
                            $order_id = $paypal_obj->ipn_data['custom'];
                            $ebook_id = $paypal_obj->ipn_data['item_number'];
//Inserting pending orders    
                            $sql = "UPDATE " . TABLE_EBOOKS_ORDERS . " 
    set                                
    payment_status='Successful',
    ipn_data='" . $ipn_data . "'                    
    where id=" . $order_id;

                            if ($wpdb->query($sql)) {
                                $msg = 'eBook order information has been saved successfully!';
                                $sql = "select * from " . TABLE_EBOOKS_ORDERS . " where id='" . $order_id . "'";
                                $order_sql = $sql;
                                $order_data = $wpdb->get_row($sql);
                            } else {
                                //mail(PAYMENT_NOTIFY_EMAILID, 'Completed can not update order status', $sql . ' This email is sending for debuging purpose only '.__FILE__);                                       
                            }


//Generating ebook download link
                            $return_options_data = editionguard_get_all_options();
                            $editionguard = new editionguard($return_options_data['settings_general_shared_secret'], $return_options_data['settings_general_editionguard_account_email']);

                            $ebook_sql = $sql = "select * from " . TABLE_EBOOKS . " where id='" . $ebook_id . "'";
                            $ebook_data = $wpdb->get_row($sql);

                            if (!empty($ebook_data) && !empty($order_data)) {

                                $resource_id = $ebook_data->resource_id;
                                //$download_link = $editionguard->fulfillment($ebook_id, $resource_id);     
                                $download_link = $editionguard->fulfillment($order_id, $resource_id);

                                if (!empty($download_link)) {
                                    $sql = "UPDATE " . TABLE_EBOOKS_ORDERS . " 
            set                                
            download_link='" . $download_link . "'          
            where id=" . $order_id;
                                    $wpdb->query($sql);
                                }

                                $title = $ebook_data->title;
                                $author = $ebook_data->author;
                                $publisher = $ebook_data->publisher;
                                $sale_price = $ebook_data->sale_price;
                                $description = $ebook_data->description;
                                $currency_code = $ebook_data->currency_code;

                                if (empty($author))
                                    $author = 'N/A';
                                if (empty($publisher))
                                    $publisher = 'N/A';
                                if (empty($description))
                                    $description = 'N/A';

                                //Sending download link to buyer email address.

                                $subject = 'Your eBook Download Link';
                                $payer_to = $order_data->email; //$paypal_obj->ipn_data['payer_email'];    // change it to payer email
                                $body = "Hi " . $order_data->first_name . ' ' . $order_data->last_name . ",
    
Thank you for shopping with us! Your order information is listed below for your convenience..

Order Details:
Order ID: $order_id
Order Status: Complete     
Amount: $sale_price $currency_code

eBook Details:
eBook Title: $title
Author: $author
Publisher: $publisher
eBook Download Link: $download_link
Details: $description

Editionguard.com        
";
                                $senderName = !empty($return_options_data['settings_general_checkout_email_sender_name']) ? $return_options_data['settings_general_checkout_email_sender_name'] : 'Support';
                                $senderEmail = !empty($return_options_data['settings_general_checkout_email_sender_email']) ? $return_options_data['settings_general_checkout_email_sender_email'] : 'support@email.com';

                                $headers = "From: $senderName <" . $senderEmail . ">\n";
                                $headers .= "Reply-To: " . $senderEmail . "\n";
                                $headers .= "Return-Path: " . $senderEmail . "\n";


                                mail($payer_to, $subject, $body, $headers);
                                mail(PAYMENT_NOTIFY_EMAILID, $subject, $body, $headers);
                                $paypal_obj->error_out("This was a download email generated and sent to buyer:\n" . $body, $em_headers);
                            } else {
                                //mail('tojibon@gmail.com', 'Completed order error', "Order details or ebook details is empty can not sent download email link" . $order_sql . ' ' . $ebook_sql . 'This email is sending for debuging purpose only '.__FILE__);                                       

                                $paypal_obj->error_out("Order details or ebook details is empty can not sent download email link" . $order_sql . ' ' . $ebook_sql, $em_headers);
                            }







//######## Send mail to PAYER for successful transaction.#########
                            $subject = 'Instant Payment Notification - Received Payment';
                            $to = $paypal_obj->error_email;    // change it to payer email
//$payer_to = $paypal_obj->ipn_data['payer_email'];    // change it to payer email
                            $body = "An instant payment notification was successfully received\n";
                            $body .= "from " . $paypal_obj->ipn_data['payer_email'] . " on " . date('m/d/Y');
                            $body .= " at " . date('g:i A') . "\n\nDetails:\n";
                            $headers = "From: $senderName <" . $senderEmail . ">\n";
                            $headers .= "Reply-To: " . $senderEmail . "\n";
                            $headers .= "Return-Path: " . $senderEmail . "\n";

                            foreach ($paypal_obj->ipn_data as $key => $value) {
                                $body .= "\n$key: $value";
                            }

                            mail($to, $subject, $body, $headers);
//######## Send mail to PAYER for successful transaction.#########
//############## Mail to admin ####################
                            $paypal_obj->error_out("This was a successful transaction:\n" . $body, $em_headers);
//############## Mail to admin ####################
                        } else {
                            $paypal_obj->error_out("This was a duplicate transaction", $em_headers);
                        }
                    }
                    break;

                case 'Failed':

                    $ipn_data = serialize($paypal_obj->ipn_data);
                    $order_id = $paypal_obj->ipn_data['custom'];
                    $sql = 'UPDATE ' . TABLE_EBOOKS_ORDERS . ' 
    set                                      
    
    payment_status="Failed",
    ipn_data="' . $ipn_data . '"                 
    
    where id=' . $order_id;

                    if ($wpdb->query($sql)) {
                        $msg = 'eBook order information has been saved successfully!';
                    }

//mail(PAYMENT_NOTIFY_EMAILID, 'Completed Validation Failed', $sql . 'This email is sending for debuging purpose only '.__FILE__);                                       
// this will only happen in case of echeck.
                    $paypal_obj->error_out("Failed Payment", $em_headers);
                    break;

                case 'Denied':

                    $ipn_data = serialize($paypal_obj->ipn_data);
                    $order_id = $paypal_obj->ipn_data['custom'];
                    $sql = 'UPDATE ' . TABLE_EBOOKS_ORDERS . ' 
    set                                      
    
    payment_status="Denied",
    ipn_data="' . $ipn_data . '"
    
    where id=' . $order_id;

                    if ($wpdb->query($sql)) {
                        $msg = 'eBook order information has been saved successfully!';
                    }

//mail(PAYMENT_NOTIFY_EMAILID, 'Completed Validation Denied', $sql . 'This email is sending for debuging purpose only '.__FILE__);                                       
// denied payment by us
                    $paypal_obj->error_out("Denied Payment", $em_headers);
                    break;

                case 'Refunded':

                    $ipn_data = serialize($paypal_obj->ipn_data);
                    $order_id = $paypal_obj->ipn_data['custom'];
                    $sql = 'UPDATE ' . TABLE_EBOOKS_ORDERS . ' 
    set                                      
    
    payment_status="Refunded",
    ipn_data="' . $ipn_data . '"
    
    where id=' . $order_id;

                    if ($wpdb->query($sql)) {
                        $msg = 'eBook order information has been saved successfully!';
                    }

//mail(PAYMENT_NOTIFY_EMAILID, 'Completed Validation Refunded', $sql . 'This email is sending for debuging purpose only '.__FILE__);                                       
// payment refunded by us
                    $paypal_obj->error_out("Refunded Payment", $em_headers);
                    break;

                case 'Canceled':

                    $ipn_data = serialize($paypal_obj->ipn_data);
                    $order_id = $paypal_obj->ipn_data['custom'];
                    $sql = 'UPDATE ' . TABLE_EBOOKS_ORDERS . ' 
    set                                      
    
    payment_status="Canceled",
    ipn_data="' . $ipn_data . '"
    
    where id=' . $order_id;

                    if ($wpdb->query($sql)) {
                        $msg = 'eBook order information has been saved successfully!';
                    }

//mail(PAYMENT_NOTIFY_EMAILID, 'Completed Validation Canceled', $sql . 'This email is sending for debuging purpose only '.__FILE__);                                       
// reversal cancelled
// mark the payment as dispute cancelled
                    $paypal_obj->error_out("Cancelled reversal", $em_headers);
                    break;

                default:
// order is not good
                    $paypal_obj->error_out("Unknown Payment Status - " . $paypal_obj->ipn_data['payment_status'], $em_headers);
//mail(PAYMENT_NOTIFY_EMAILID, 'Unknown Payment Status', $paypal_obj->ipn_data['payment_status'] . 'This email is sending for debuging purpose only '.__FILE__);                                       
                    break;
            }
            break;
    }
}


if (!empty($payment_form_submit_error) || empty($_REQUEST['action'])) {
    $payment_page_uri = add_query_arg('action', 'process', $payment_page_uri);
    $button_output = '<div id="checkout_form">
    <form id="paypal_payment_form" name="paymentForm" method="post" action="' . $payment_page_uri . '#ebook_details">
    <h2>Personal Information</h2>
    ' . $payment_form_submit_error . '
    <p>
        <label>First Name:</label><input type="text" name="first_name" value="' . $_POST['first_name'] . '">
    </p>
    <p>
        <label>Last Name:</label><input type="text" name="last_name" value="' . $_POST['last_name'] . '">
    </p>
    <p>
        <label>Email Address:</label><input type="text" name="email" value="' . $_POST['email'] . '"><br/><br/>
            <i>Please enter a valid e-mail address, as your eBook download link will be e-mailed to you.</i>
    </p>
    <input type="hidden" name="item_number" value="' . $id . '" />            
    <input type="hidden" name="item_name" value="' . $title . '" />
    <input type="hidden" name="total_cost" value="' . $sale_price . '"/>        
    <input type="hidden" name="currency_code" value="' . $currency_code . '"/>
    <input class="paypal_pay_button" type="submit" value="Make payment using Paypal"/>
    </form>
    </div>';
}
