<?php
    require_once('../../../../../wp-load.php');
    require_once('../../../../../wp-admin/includes/admin.php');
    
    if ( ! is_user_logged_in() )
        die('You must be logged in to access this script.');
    
    
?>
<!DOCTYPE html>
<head>
    <title>Create Ebook Shortcode</title>
    <script type="text/javascript" src="../../../../../wp-includes/js/jquery/jquery.js"></script>
    <script type="text/javascript" src="../../../../../wp-includes/js/tinymce/tiny_mce_popup.js"></script>
    <link rel='stylesheet' id='shortcode-ui-css'  href='../../css/shortcode-ui-css.css' type='text/css' media='all' />
    <script type="text/javascript">
        //More JS Here Later
        
        var EbookTiny = {
            e: '',
            init: function(e) {
                EbookTiny.e = e;
                tinyMCEPopup.resizeToInnerSize();
            },
            insert: function createEbookShortcode(e) {
                var Ebook = parseInt(jQuery('#Ebook').val());
                var PaymentType = jQuery('#PaymentType').val(); 
                
                var output = '';
                var val = '';
                if(typeof(Ebook) === 'undefined' || Ebook=='' || typeof(PaymentType) === 'undefined' || PaymentType==''){                    
                    
                } else {
                    output+='[ebook payment="'+PaymentType+'" id="'+Ebook+'"]';
                }
                output+="";
                
                
                tinyMCEPopup.execCommand('mceReplaceContent', false, output);

                tinyMCEPopup.close();

            },
            
            
        }
        tinyMCEPopup.onInit.add(EbookTiny.init, EbookTiny);
        
        function closeMe() {
                tinyMCEPopup.close();
            }   
    
    </script>
</head>
<body>
<form id="EbookShortcode">
    <h2>Generate Ebook Shortcode</h2>
    
    <div id="contentWrap">
        <div id="itemRow_1">
            <p>
                <label>Select A Ebook:</label>
                <?php 
                $sql="select * from ".TABLE_EBOOKS." where status='active' ORDER BY  title";
                $ebook_list=$wpdb->get_results($sql);   
                ?>
                <select class="input Ebook" id="Ebook" name="Ebook" style="width:160px; padding: 2px 5px;">
                <?php 
                foreach($ebook_list as $row){
                    ?>
                    <option value="<?=$row->id?>"><?=$row->title?></option>  
                    <?php 
                }
                ?>                                              
                </select>
            </p>
            <p>
                    <input type='hidden' class="input PaymentType" id='PaymentType' name='PaymentType' value='paypal' />
<!--                    <label>Payment Type:</label>
                    <select class="input PaymentType" id="PaymentType" name="PaymentType" style="width:160px; padding: 2px 5px;">
                        <option value="paypal">Paypal</option>
                        <option value="both">Both</option>  
                    </select>-->
            </p>
        </div>
    </div>
    <p style="margin-top: 40px;"><a href="javascript:EbookTiny.insert(EbookTiny.e)"><input type="button" class="button" name="insert" value="Insert Into Post"></a>
    
    <a href="javascript:closeMe();"><input type="button" class="button" name="close" value="Close X"></a></p>
</form>
</body>
</html>