(function() {
    var eDobj;
    var currentSelectedShortcode = '';
    var thisUrl = '';
    
    
	tinymce.create('tinymce.plugins.Ebook', {
		init : function(ed, url) {
            ed.addCommand('addCommandEbook', function() {
                if(currentSelectedShortcode=='')
                    return false;
                    
                    
                ed.windowManager.open({
                    file : url + '/'+currentSelectedShortcode+'/index.php',
                    width : 550,
                    height : 260,
                    inline : 1
                }, {
                    plugin_url : url
                });
            });
            
            eDobj = ed;
            thisUrl = url;
        },
        
		createControl : function(n, cm) {
                
			if(n=='ebook'){
                eDobj.addButton('ebook', {
                    title : 'EditionGuard Ebook Shortcode',
                    image : thisUrl+'/images/eg_logo_tiny.png',
                    onclick : function() {
                        currentSelectedShortcode = 'ebook';  
                        eDobj.execCommand('addCommandEbook');
                    }
                });
                
             }
             
             return null;
		},
		getInfo : function() {
			return {
				longname : "Editionguard Ebook Shortcode",
				
			};
		}
	});
	tinymce.PluginManager.add('ebook', tinymce.plugins.Ebook);
})();